# Data model API

In scripts, validators, and script tasks, we can use the data model API

```
interface Model {
   get(key || key[] :string): string;                    // Retrieve a variable from the data model with the specified id
   indexes(key[] : string): List<String>;                // Retrieve the indexes of the specified key from an array
}
```

### GET

To use values from the data model, use the API shown in the code fragment below:

```js
function callService(input){
    const valueFromModel = api.model.v1.get("user.pesel"); // Retrieve the PESEL from a single model node -> "12312312311"
    let customersLastName = api.model.v1.get("BazaOfert.Kredytobiorcy[0].Nazwisko") // Retrieve the last name from index 0 -> "Kowalski"
    let customersPesel = api.model.v1.get("BazaOfert.Kredytobiorcy[].PESEL") // Retrieve all PESELs from the array -> "74082109492,49020106066"
    return [{'output':customerLastName}]
}
```

### INDEXES

To retrieve the list of indexes for an array, use the API shown in the code fragment below:

```js
 const answersIndexes = api.model.v1.indexes("Survey.Questions[]")
 let surveyResults = answersIndexes.map((idx) => {
        return {
            "question": api.model.v1.get(`Survey.Questions[${idx}].Content`),
            "answer": api.model.v1.get(`Survey.Questions[${idx}].Answer`)
        }
    })
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.eximee.com/documentation/documentation-en/budowanie-aplikacji/model-danych/wykorzystanie-modelu-danych/api-modelu-danych.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
